/*此示例必须与Blinker app联动，下载方式和更多相关资料请访问https://blinker.app/   */

//更多资料欢迎访问我们的官网 http://openjumper.cn/ 或联系邮箱 support@openjumper.com
//https://openjumper.taobao.com/ --OPENJUMPER官方店铺
//https://shop555818949.taobao.com/ --OPENJUMPER企业店铺


#define BLINKER_PRINT Serial
#define BLINKER_BLE
#include <math.h>
#include <Blinker.h>

#define IN4 7
#define IN3 6
#define IN1 4
#define IN2 5
#define ROTATE    -(PI/4) //定义坐标系旋转角度  -45
//#define C_BAR_PIN       9
unsigned long t = 0;

//uint32_t car_os_time = millis();
bool isWarn = false;
#define JOY_1 "JOYKey"

BlinkerJoystick JOY1(JOY_1);

void joystick1_callback(uint8_t xAxis, uint8_t yAxis)
{
  //Serial.print(xAxis);
  //Serial.print(" ");
  //Serial.println(yAxis);


  t = millis();
  blinker_car_parse(xAxis, yAxis);
}

void blinker_car_parse(uint8_t xAxis, uint8_t yAxis)
{
  uint8_t L_PWM = 255;
  uint8_t R_PWM = 255;
  bool    L_DIR = true;
  bool    R_DIR = true;
  if ((xAxis != 128) && (xAxis != 128)) {
    float x = xAxis - 128.0;
    float y = yAxis - 128.0;
    float l = sqrt(x * x + y * y);
    float a = atan2(y, x) + ROTATE;
    int i = l * cos(a);
    int j = l * sin(a);
    //Serial.print(i);
    //Serial.print(" ");
    //Serial.println(j);
    if (i > 128) i = 128;
    else if ( i < -127) i = -127;
    if (i > 0) L_DIR = true;
    else  L_DIR = false;
    L_PWM = 128 - i;

    if (j > 128) j = 128;
    else if (j < -127) j = -127;
    if (j > 0) R_DIR = true;
    else  R_DIR = false;
    R_PWM = 128 - j;
    /*Serial.print(L_DIR);
    Serial.print(" ");
    Serial.print(R_DIR);
    Serial.print(" L");
    Serial.print(L_PWM);
    Serial.print(" R");
    Serial.println(R_PWM);*/
    //Serial.println("r");
  }
  else {
    //Serial.println("s");
  }
  analogWrite(IN3, L_PWM);
  analogWrite(IN2, R_PWM);
  digitalWrite(IN4, L_DIR);
  digitalWrite(IN1, R_DIR);
}
void blinker_car_init()
{
  pinMode(IN4, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  analogWrite(IN3, 255);
  analogWrite(IN2, 255);
  digitalWrite(IN4, 1);
  digitalWrite(IN1, 1);
  //  pinMode(C_BAR_PIN, INPUT_PULLUP);
}
void blinker_car_control(uint8_t cl_pwm, bool cl_dir, uint8_t cr_pwm, bool cr_dir)
{
  digitalWrite(IN4, cl_dir);
  digitalWrite(IN1, cr_dir);
  analogWrite(IN3, cl_pwm);
  analogWrite(IN2, cr_pwm);
}
/*
  void blinker_car_detect()
  {
    if (!digitalRead(C_BAR_PIN)) {
        if (!isWarn) {
            Blinker.vibrate();
            isWarn = true;
            car_os_time = millis();
        }
        else if (millis() - car_os_time >= 5000) {
            isWarn = false;
        }
    }
    else {
        isWarn = false;
    }
  }
*/
void setup()
{
  blinker_car_init();
  //Blinker.begin();
  Blinker.begin(0, 1);
  JOY1.attach(joystick1_callback);
}

void loop()
{
  Blinker.run();
  if ((millis() - t) > 2000) {
    t = millis();
    blinker_car_init();
    Serial.println("timeout");
  }
  //   blinker_car_detect();
  /*#if defined(BLINKER_CAR_DEBUG)
    BLINKER_LOG4("L_PWM: ", L_PWM, "  | L_DIR: ", L_DIR);
    BLINKER_LOG4("R_PWM: ", R_PWM, "  | R_DIR: ", R_DIR);
    Blinker.delay(2000);
    #endif*/
}
